/*
 * MAX6675.c
 *
 *  Created on: Oct 26, 2023
 *      Author: martin
 */

/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "COPFree.h"
#include "PTB.h"
#include "MAX6675.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"
#include <stdlib.h>

void Delay_10us(void) {
	
	 asm { 
		 CLR $82
		 MOV #$7, $82
	    b:
	      NOP
	      DBNZ $82, b
	  }
}
void Max6675_Init()
{
   Pin_CS=1; 
   Pin_CLK=0;
   Cpu_Delay100US(1000);
}

char Max6675_Pulso()
{
char lei;

  Pin_CLK=1; //clock enable 
  Delay_10us();
  lei=Pin_Data; 
  Pin_CLK=0; //cloack disable
  Delay_10us();
  
  return lei;
}

long Max6675_Read(uint8_t cf)
{
unsigned int sensor_dato;

unsigned int max6675_dato=0;
signed char cont;

    Pin_CS=0;    // enable module

    for (cont=15;cont>=0;cont--)
    {
      if (Max6675_Pulso()==1)  max6675_dato=max6675_dato | 1<<cont ;

    }

    Pin_CS=1;   //disable module 
    
    sensor_dato=(max6675_dato>>3 ); //scroll 3 spaces
    if(cf==1) return((sensor_dato*45)+3200);
    if(cf==0) return(sensor_dato*25);
}
