/* ###################################################################
**     Filename    : main.c
**     Project     : example_5
**     Processor   : MC9S08SE8CWL
**     Version     : Driver 01.12
**     Compiler    : CodeWarrior HCS08 C Compiler
**     Date/Time   : 2023-10-26, 17:28, # CodeGen: 0
**     Abstract    :
**         Main module.
**         This module contains user's application code.
**     Settings    :
**     Contents    :
**         No public methods
**
** ###################################################################*/
/*!
** @file main.c
** @version 01.12
** @brief
**         Main module.
**         This module contains user's application code.
*/         
/*!
**  @addtogroup main_module main module documentation
**  @{
*/         
/* MODULE main */


/* Including needed modules to compile this module/procedure */
#include "Cpu.h"
#include "Events.h"
#include "COPFree.h"
#include "PTB.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

/* User includes (#include below this line is not maintained by Processor Expert) */

#include "I2C_Software.h"
#include "I2C_LCD2x16.h"
#include "MAX6675.h"

#define PORTB_D7  PTBD_PTBD7

signed char  ch[7], i=0;
long Temp1;

void print_Temp(void)
{
  for(i=0; i<=6; i++) 
  {
    I2C_LCD_Chr(2, 5+i, ch[i]+48);
  }
  
  Cpu_Delay100US(5000);  
}

void main(void)
{
  /* Write your local variable definition here */
	   uint8_t FC=0, level =0;
  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/
   
  /* Write your code here */
  COPFree_Init();
  PTB_Init();
  PTBDD_PTBDD3 = 0;
  PTBDD_PTBDD7 = 0;
  Max6675_Init(); 
  I2C_LCD_Init();
  I2C_LCD_Cmd(_LCD_CLEAR);
  I2C_LCD_Cmd(_LCD_CURSOR_OFF);
  I2C_LCD_Out(1,4,"Temperature");
  I2C_LCD_Chr(2,13,223);   // Print degree character.

  for(;;) {
	       
	       if(PORTB_D7==0) {
	    	  Cpu_Delay100US(50);  
	 		 if(PORTB_D7==0)level =1, Cpu_Delay100US(100); 
	 	   }
	 	  if((PORTB_D7==1)&& (level==1))FC++, level=0; 
	  
	 	  if(FC>1)FC=0;//celsius =0 ,fahrenheit=1
	      Temp1 = Max6675_Read(FC);
	      if(FC==0) I2C_LCD_Chr(2,14,67);    // C character
	      if(FC==1) I2C_LCD_Chr(2,14,70);    // F character
	      ch[0] =  Temp1 / 100000;
	      ch[1] = (Temp1 / 10000)%10;
	      ch[2] = (Temp1 / 1000)%10;
	      ch[3] = (Temp1 / 100)%10;
	      ch[4] = -2; //(.)point character
	      ch[5] = (Temp1 /10)%10;
	      ch[6] =  Temp1%10;
	      if(Temp1<100000)ch[0]=-16;//this value is to get a 32 = space 
	      if((Temp1<10000))ch[1]=-16;
	      if((Temp1<1000))ch[2]=-16;
	      print_Temp();
	       
  }
  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** RTOS startup code. Macro PEX_RTOS_START is defined by the RTOS component. DON'T MODIFY THIS CODE!!! ***/
  #ifdef PEX_RTOS_START
    PEX_RTOS_START();                  /* Startup of the selected RTOS. Macro is defined by the RTOS component. */
  #endif
  /*** End of RTOS startup code.  ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
} /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/

/* END main */
/*!
** @}
*/
/*
** ###################################################################
**
**     This file was created by Processor Expert 10.3 [05.09]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
